unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLWin32Viewer, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses,jpeg, StdCtrls, math, ExtCtrls,
  GLGeomObjects, ComCtrls, VectorTypes, GLMesh,
  GLColor, GLState, VectorGeometry;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLSceneViewer1: TGLSceneViewer;
    GLLightSource2: TGLLightSource;
    Button1: TButton;
    Button2: TButton;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    GLMesh1: TGLMesh;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    StatusBar3: TStatusBar;
    StatusBar4: TStatusBar;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button3: TButton;
    Shape1: TShape;
    Label5: TLabel;
    ColorDialog1: TColorDialog;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    px,py   : integer;
    ss,LL   : single;
    colOR   : TVector4f;
    mi,ma,
    centro  : TVector3f;

    Avert   : array of TVector3f;
    Atria   : array of TVector3i;
    np,nt   : integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  colOR := GLLightSource2.Diffuse.Color;
  ss := GLCamera1.SceneScale;

  Form1.Icon.LoadFromFile('Objects.ico');
  Application.Icon.LoadFromFile('Objects.ico');

  GLMesh1.Vertices.Clear;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.05;
  if ss<0.2 then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.05;
  if ss > 4 then ss := 4;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
 vv : integer;
 vr : single;
begin
  vv := TrackBar1.Position;
  Label1.Caption := IntToStr(vv);

  vr := vv/100;
  GLLightSource1.Diffuse.SetColor(vr,vr,vr);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
var
 vv  : integer;
 vr  : single;
begin
  vv := TrackBar2.Position;
  Label3.Caption := IntToStr(vv);

  vr := vv/100;

  GLLightSource2.Diffuse.SetColor(colOR[0]*vr,
                                  colOR[1]*vr,
                                  colOR[2]*vr);
end;

// Color del parche
procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ColorDialog1.Execute then begin
    Shape1.Brush.Color := ColorDialog1.Color;
  end;
end;

// ----------------  Abrir Archivo  -------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  nom    : string;
  fid    : TextFile;
  kk,jj  : integer;
  dum    : integer;
  Esc    : single;
begin
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;
    AssignFile(fid,nom);
    reset(fid);

    // saltar letrero
    readln(fid);

    // leer num de puntos y triangulos
    readln(fid,np,nt);
    StatusBar1.Panels[0].Text := IntToStr(np);
    StatusBar1.Panels[1].Text := IntToStr(nt);

    // leer vrtices
    SetLength(Avert,np);

    // cotas
    readln(fid,Avert[0][0],Avert[0][1],Avert[0][2]);
    mi[0] := Avert[0][0]; ma[0] := mi[0];
    mi[1] := Avert[0][1]; ma[1] := mi[1];
    mi[2] := Avert[0][2]; ma[2] := mi[2];

    for kk := 1 to np - 1 do begin
      readln(fid,Avert[kk][0],Avert[kk][1],Avert[kk][2]);
      for jj := 0 to 2 do begin
        mi[jj] := MIN(mi[jj],Avert[kk][jj]);
        ma[jj] := MAX(ma[jj],Avert[kk][jj]);
      end;
    end;

    for jj := 0 to 2 do begin
      StatusBar1.Panels[2+2*jj  ].Text := Format('%8.5f',[mi[jj] ]);
      StatusBar1.Panels[2+2*jj+1].Text := Format('%8.5f',[ma[jj] ]);
    end;

    // centro de la caja
    for jj := 0 to 2 do begin
       Centro[jj] := (ma[jj] + mi[jj])/2;
       StatusBar1.Panels[8+jj].Text := Format('%8.5f',[Centro[jj] ]);
    end;

    // lado mayor de la caja de contencin
    LL := ma[0] - mi[0];
    for jj := 1 to 2 do LL := MAX(LL, ma[jj] - mi[jj]);

    Esc  := 2/LL;

    // trasladamos todos los vertices al Centro Hallado y los escalamos
    for kk := 0 to np - 1 do begin
      SubtractVector( Avert[kk], Centro);
      ScaleVector( Avert[kk], Esc );
    end;

    // leer triangulos
    SetLength(Atria,nt);
    for kk := 0 to nt - 1 do
      readln(fid,dum,Atria[kk][0],Atria[kk][1],Atria[kk][2]);

    closeFile(fid);
  end;

end;

// dibujar
procedure TForm1.Button2Click(Sender: TObject);
var
  nor          : TVector3f;
  col          : TVector4f;
  colorSH      : integer;
  kk           : integer;
  p,q,r        : integer;

begin
  GLMesh1.Vertices.Clear;
  GLMesh1.Scale.SetVector(1,1,1);
  GLMesh1.Position.SetPoint(0,0,0);

  nor[0] := 0; nor[1] := 0; nor[2] := 0;

  colorSH := Shape1.Brush.Color;
  col[0] := GetRValue(colorSH)/255;
  col[1] := GetGValue(colorSH)/255;
  col[2] := GetBValue(colorSH)/255;

  for kk := 0 to nt-1 do begin
    p := Atria[kk][0];
    q := Atria[kk][1];
    r := Atria[kk][2];

    GLMesh1.Vertices.AddVertex(Avert[p],nor,col);
    GLMesh1.Vertices.AddVertex(Avert[q],nor,col);
    GLMesh1.Vertices.AddVertex(Avert[r],nor,col);
  end;
  GLMesh1.CalcNormals(fwCounterClockWise);

  // reporta posicin
  for kk := 0 to 2 do
     StatusBar3.Panels[kk].Text := Format('%8.5f',
                                   [GLMesh1.Position.AsVector[kk] ]);

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  kk : integer;
  tx,ty,tz  : single;
begin
  tx := StrToFloat(Edit1.Text);
  ty := StrToFloat(Edit2.Text);
  tz := StrToFloat(Edit3.Text);

  GLMesh1.Translate(tx,ty,tz);

  // reporta posicin
  for kk := 0 to 2 do
     StatusBar3.Panels[kk].Text := Format('%8.5f',
                                   [GLMesh1.Position.AsVector[kk] ]);

end;

end.
